# -*- coding: utf-8 -*-

import pylab


# lasketaan kokonaislukujen 1..k summa for-silmukan avulla
# tulostetaan joka kierroksella välitulos
# huom. Pythonin range(k) antaa luvut 0:sta (k-1):een.
# Kokeile konsolilla
def summa(k):
    s = 0
    for i in range(k+1):
        s = s+(i)
        print("i: ", i, "s: ", s)
    return s


# lasketaan kokonaiskukujen 1..k rekursiivisella funktiolla.
# Rekursiossa funktio kutsuu itseään, kunnes lopetusehto
# (tässä tapauksessa k == 0) toteutuu.
def summaR(k):
    print("summaR ", k)
    if k == 0:
        return 0
    return k+summaR(k-1)


# Esimerkkejä eri tavoista saada tulostettua jotain konsolille
def mjonot():
    s = "Tämä on merkkijono "
    m = 53
    print(s)
    print("luku ja merkkijono ", m, str(m))
    print("kaksi merkkijonoa yhdistetty + merkillä: ")
    print(s+str(m))
    m = 120
    n = 15
    print(m+n)
    print(str(m)+str(n))
    print(str(m)+' '+str(n))


# Esimerkki siitä, miten lukea konsolilta.
# Input tuottaa merkkijonon, joten muutamme sen int()-funktiolla
# kokonaisluvuksi
def kysymys():
    N = input("anna luku: ")
    print('luku on:', N, type(N))
    S = summa(int(N))
    print("lukujen 1..", N, " summa on: ", S)
    print("lukujen 1.."+str(N)+" summa on: "+str(S))


# piirretään funktion y = x**5 kuvaaja
# Muodostetaan listat/taulukot xx ja yy toisiaan vastaavilla
# x ja y arvoille.
# loppu hoituu pylab-funktioilla
# huom. Pythonin range(i,j) antaa luvut i:stä (j-1):een.
# Kokeile konsolilla
def kuvaaja():
    xx = [i for i in range(-10, 11)]
    yy = [i**3 for i in xx]

    print("xx:")
    print(xx)
    print("yy:")
    print(yy)

    pylab.plot(xx, yy)
    pylab.title('y = x**3')
    pylab.ylabel("x**3")
    pylab.xlabel("x")
    pylab.savefig('y_x3.png')
    pylab.show()

# Huom. Merkkijoissa \n aiheuttaa rivinvaihdon
print('\npääohjelma\n')

print("summa(5):")
s = summa(5)
print(s)
print("\nsummaR(5): ")
s = summaR(5)
print(s)

print("\nmerkkijonot")
mjonot()

kysymys()

print("\nkuvaaja:")
kuvaaja()

# voit kutsua funktiota konsolilta
